#!/bin/bash

# Create dir if it does not already exist.
if [ -d "reports" ]; then
    echo "Dir reports already exists. Deleting dir."
    rm -r reports
fi

mkdir reports

week=("monday" "tuesday" "wednesday" "thursday" "friday" "saturday" "sunday")

echo "Array size: ${#week[*]}"
echo "Array:"
for index in ${!week[*]}
do
    printf "%4d: %s\n" $index ${week[$index]}
done

product=("apple" "orange" "potato" "tomato")
price_per_kg=(4 15 2 29)

for day in ${week[*]}
do
    file=reports/$day.txt
    touch $file
    num_sales=$[ ( $RANDOM % 100 ) + 1]
    echo "sale,quota,product_index,product_name,price" >> $file
    for (( sale=1; sale<=$num_sales; sale++ ))
    do
        product_index=$[ $RANDOM % 4 ]
        product_name=${product[$product_index  ]}
        quota=$[ $RANDOM % 25 + 1 ]
        price=$(($quota*${price_per_kg[$product_index]}))
        echo "$sale,$quota,$product_index,$product_name,$price" >> $file
    done
done
